]> arthur.barton.de Git - backup-script.git/blobdiff - bin/backup-script
Use relative symlinks for ZFS snapshots
[backup-script.git] / bin / backup-script
index 3ce8db15e802af8b0393a2830f43ad7739685777..185a62f970db7f830d34f4955d239cb1ec72275e 100755 (executable)
@@ -26,15 +26,18 @@ declare -i count_ok_vanished=0
 destinations=""
 
 # Default settings, can be overwritten in backup-script.conf:
-conf_d="/etc/backup-script.d"
+[ -d "/usr/local/etc/backup-script.d" ] \
+       && conf_d="/usr/local/etc/backup-script.d" \
+       || conf_d="/etc/backup-script.d"
 pre_exec=""
 post_exec=""
 default_source_root="/"
-default_target=""
+default_target="/var/backups"
 default_user="root"
 default_ssh_args_add=""
 default_rsync_args_add=""
 default_exclude_args_add=""
+default_exclude_dirs_add=""
 default_compress=1
 default_ping=1
 default_local=0
@@ -50,7 +53,9 @@ Usage() {
        echo
        echo "When no <system> is given, all defined systems are used."
        echo
-       exit 1
+       echo -e $config_info
+       echo
+       exit 2
 }
 
 CleanUp() {
@@ -151,7 +156,7 @@ CloneSubvolume() {
                zfs snapshot "$snapshot" || return 1
                link_name="$(echo "$snapshot" | cut -d@ -f2-)"
                ln -s \
-                       "$volume/.zfs/snapshot/$link_name" \
+                       "current/.zfs/snapshot/$link_name" \
                        "$(dirname "$volume")/$link_name"
                ;;
          *)
@@ -258,6 +263,25 @@ Initialize_Last_SysTarget_Snapshot() {
        return 0
 }
 
+# Search configuration file (last one is used as default!)
+for conf in \
+       "/usr/local/etc/backup-script.conf" \
+       "/etc/backup-script.conf" \
+       "${conf_d}/backup-script.conf" \
+       "/usr/local/etc/backup-script.conf" \
+; do
+       [ -r "$conf" ] && break
+done
+
+# Read in configuration file
+config_info="Configuration file is \"$conf\""
+if [ -r "$conf" ]; then
+       source "$conf"
+else
+       config_info="${config_info} (not readable, using defaults)"
+fi
+config_info="${config_info},\nusing \"$conf_d\" as configuration directory."
+
 while [ $# -gt 0 ]; do
        case "$1" in
          "-n"|"--dry-run")
@@ -274,23 +298,30 @@ while [ $# -gt 0 ]; do
        esac
 done
 
-trap GotSignal SIGINT
-
 echo -n "Started: "; date
+echo -e $config_info
 
-for conf in "/etc/backup-script.conf" "${conf_d}/backup-script.conf"; do
-       if [ -r "$conf" ]; then
-               echo "Reading configuration: \"$conf\" ..."
-               source "$conf"
-       fi
-done
+# Check rsync and its protocol version
+rsync=$(which "rsync" 2>/dev/null)
+if [ $? -ne 0 ]; then
+       echo "Failed to detect rsync(1)! Is it installed in your \$PATH?"
+       exit 1
+fi
+rsync_proto=$($rsync --version 2>/dev/null | head -n 1 | sed 's/.*  protocol version \([0-9]*\)$/\1/')
+if [ $? -ne 0 ]; then
+       echo "Failed to detect protocol version of $rsync!"
+       exit 1
+fi
+echo "Rsync command is $rsync, protocol version $rsync_proto."
 echo
 
+trap GotSignal SIGINT
+
 if [ $# -ge 1 ]; then
        for s in "$@"; do
                if [ ! -r "${conf_d}/$s" ]; then
                        echo "$NAME: Can' read \"${conf_d}/$s\"!"
-                       exit 1
+                       exit 3
                fi
                sys="$sys ${conf_d}/$s"
        done
@@ -305,7 +336,7 @@ if [ -e "$PIDFILE" ]; then
        echo
        echo -n "Aborted: "; date
        echo
-       exit 3
+       exit 4
 fi
 touch "$PIDFILE" 2>/dev/null
 if [ $? -ne 0 ]; then
@@ -322,7 +353,7 @@ if [ -n "$pre_exec" ]; then
                echo "Error: pre-exec command failed!"; echo
                CleanUp
                echo "Aborting backup."; echo
-               exit 2
+               exit 5
        fi
        sleep 2
        echo
@@ -346,6 +377,7 @@ for f in $sys; do
        ssh_args_add="$default_ssh_args_add"
        rsync_args_add="$default_rsync_args_add"
        exclude_args_add="$default_exclude_args_add"
+       exclude_dirs_add="$default_exclude_dirs_add"
        compress="$default_compress"
        ping="$default_ping"
        local="$default_local"
@@ -381,7 +413,11 @@ for f in $sys; do
        post_exec="$post_exec_saved"
 
        # Validate configuration
-       [ "$system" = "localhost" -o "$system" = "127.0.0.1" ] && local=1
+       if [ "$system" = "localhost" -o "$system" = "127.0.0.1" ]; then
+               # Local system
+               local=1
+               compress=0
+       fi
 
        # Make sure "source" ends with a slash ("/")
        case "$source" in
@@ -502,18 +538,36 @@ for f in $sys; do
        fi
 
        # prepare (remote) command ...
-       cmd="rsync --archive"
+       cmd="$rsync --archive"
        [ "$compress" -ne 0 ] && cmd="$cmd --compress"
        [ "$local" -eq 0 ] && cmd="$cmd --rsh=\"$ssh_cmd\""
        cmd="$cmd --delete --delete-excluded --sparse"
-       [ "$VERBOSE" -gt 0 ] && cmd="$cmd --progress"
+       if [ "$VERBOSE" -gt 0 ]; then
+               [ "$rsync_proto" -ge 31 ] \
+                       && cmd="$cmd --info=progress2" \
+                       || cmd="$cmd --progress"
+       fi
        if [ "$source_root" = "$default_source_root" ]; then
-               cmd="$cmd --exclude=/dev --exclude=/proc --exclude=/sys"
-               cmd="$cmd --exclude=/run --exclude=/tmp --exclude=/var/tmp"
-               cmd="$cmd --exclude=/media --exclude=/mnt --exclude=/net"
-               cmd="$cmd --exclude=/var/cache/apt --exclude=/var/log"
+               for dir in \
+                       "/dev/**" \
+                       "/media/**" \
+                       "/mnt/**" \
+                       "/net/**" \
+                       "/proc/**" \
+                       "/run/**" \
+                       "/sys/**" \
+                       "/tmp/**" \
+                       "/var/cache/apt/**" \
+                       "/var/log/**" \
+                       "/var/tmp/**" \
+               ; do
+                       cmd="$cmd --exclude=$dir"
+               done
        fi
        [ -n "$exclude_args_add" ] && cmd="$cmd $exclude_args_add"
+       for dir in $exclude_dirs_add; do
+               cmd="$cmd --exclude=$dir"
+       done
        [ -n "$rsync_args_add" ] && cmd="$cmd $rsync_args_add"
 
        [ "$local" -eq 0 ] \
@@ -537,8 +591,7 @@ for f in $sys; do
 
        if [ $ret -eq 20 ]; then
                echo "Backup of \"$system\" interrupted. Aborting ..."
-               CleanUp
-               exit 1
+               GotSignal
        fi
 
        echo -n "End date: "; date
@@ -599,10 +652,27 @@ done
 
 sync
 
-paths=$( echo $destinations | sed -e 's/ /\n/g' | sort | uniq )
-if [ "$DRYRUN" -eq 0 -a -n "$paths" ]; then
-       df -h $paths
-       echo
+if [ "$DRYRUN" -eq 0 ]; then
+       paths=""
+       paths_zfs=""
+       for dest in $(echo $destinations | sed -e 's/ /\n/g' | sort | uniq); do
+               fs=$(GetFS "$dest")
+               case $fs in
+                 "zfs" )
+                       paths_zfs="$paths_zfs $dest"
+                       ;;
+                 *)
+                       paths="$paths $dest"
+               esac
+       done
+       if [ -n "$paths" ]; then
+               df -h $paths
+               echo
+       fi
+       if [ -n "$paths_zfs" ]; then
+               zfs list $paths_zfs
+               echo
+       fi
 fi
 
 CleanUp
@@ -619,6 +689,9 @@ echo
 if [ $count_started -ne $count_ok ]; then
        echo "----->  THERE HAVE BEEN ERRORS!  <-----"
        echo
+       exit 6
+elif [ $count_all -ne $count_started ]; then
+       exit 7
 fi
 
 # -eof-